'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _isNonEditableFieldTy;
// import {Table, TableBody, TableRow, div} from 'material-ui/Table'


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _intl_helpers = require('../../util/intl_helpers');

var _formatted_value = require('../shared/formatted_value');

var _formatted_value2 = _interopRequireDefault(_formatted_value);

var _formatted_fieldname = require('../shared/formatted_fieldname');

var _formatted_fieldname2 = _interopRequireDefault(_formatted_fieldname);

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _visibility = require('material-ui/svg-icons/action/visibility');

var _visibility2 = _interopRequireDefault(_visibility);

var _visibilityOff = require('material-ui/svg-icons/action/visibility-off');

var _visibilityOff2 = _interopRequireDefault(_visibilityOff);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _SelectField = require('material-ui/SelectField');

var _SelectField2 = _interopRequireDefault(_SelectField);

var _MenuItem = require('material-ui/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _pure = require('recompose/pure');

var _pure2 = _interopRequireDefault(_pure);

var _constants = require('../../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var messages = (0, _reactIntl.defineMessages)({
  visibility: {
    'id': 'featureDetail.visibilitySwitch',
    'defaultMessage': 'Hide or show field'
  }
});

var styles = {
  firstColumn: {
    fontWeight: 'bold',
    flex: 'initial',
    textAlign: 'right'
  },
  column: {
    padding: 12,
    whiteSpace: 'normal',
    flex: 1
  },
  secondColumnEdit: {
    padding: '0 12px'
  },
  row: {
    lineHeight: 1.4,
    display: 'flex'
  },
  smallRow: {
    paddingTop: 4,
    paddingBottom: 4
  },
  textField: {
    fontSize: 14,
    lineHeight: '17px',
    height: 39,
    marginTop: -12
  },
  fieldUnderline: {
    bottom: 4,
    borderBottom: '1px dashed #c0c0c0',
    borderColor: '#c0c0c0'
  }
};

var ValueCell = function ValueCell(_ref) {
  var value = _ref.value,
      type = _ref.type,
      coordFormat = _ref.coordFormat;
  return _react2.default.createElement(_formatted_value2.default, { value: value, type: type, coordFormat: coordFormat });
};

var ValueCellEdit = (0, _pure2.default)(function (_ref2) {
  var value = _ref2.value,
      type = _ref2.type,
      coordFormat = _ref2.coordFormat,
      _ref2$fieldMetadata = _ref2.fieldMetadata,
      fieldMetadata = _ref2$fieldMetadata === undefined ? {} : _ref2$fieldMetadata,
      onChange = _ref2.onChange;

  var values = type === _constants.FIELD_TYPE_BOOLEAN ? [true, false] : Array.isArray(fieldMetadata.values) && fieldMetadata.values.map(function (d) {
    return d.value;
  });
  var isDiscreteField = type === _constants.FIELD_TYPE_STRING && fieldMetadata.values && fieldMetadata.values.length / fieldMetadata.count < 0.8;
  if (isDiscreteField || type === _constants.FIELD_TYPE_BOOLEAN) {
    return _react2.default.createElement(
      _SelectField2.default,
      {
        style: styles.textField,
        underlineStyle: styles.fieldUnderline,
        iconStyle: { height: 39, padding: 7 },
        labelStyle: { height: 35, lineHeight: '39px', top: 0 },
        autoWidth: true,
        fullWidth: true,
        value: value,
        onChange: onChange },
      values.map(function (d) {
        return _react2.default.createElement(_MenuItem2.default, {
          key: d,
          value: d,
          style: { fontSize: 13 },
          primaryText: d === 'undefined' ? '' : _react2.default.createElement(_reactIntl.FormattedMessage, (0, _intl_helpers.createMessage)('field_value')(d))
        });
      })
    );
  }
  if (type === _constants.FIELD_TYPE_STRING || type === _constants.FIELD_TYPE_MIXED) {
    return _react2.default.createElement(_TextField2.default, {
      fullWidth: true,
      multiLine: true,
      underlineStyle: styles.fieldUnderline,
      value: value,
      onChange: onChange,
      style: styles.textField });
  }
  if (type === _constants.FIELD_TYPE_ARRAY) {
    return _react2.default.createElement(
      _SelectField2.default,
      {
        style: styles.textField,
        underlineStyle: styles.fieldUnderline,
        iconStyle: { height: 39, padding: 7 },
        labelStyle: { height: 35, lineHeight: '39px', top: 0 },
        multiple: true,
        autoWidth: true,
        fullWidth: true,
        value: value,
        selectionRenderer: function selectionRenderer(value) {
          return _react2.default.createElement(_reactIntl.FormattedMessage, (0, _intl_helpers.createMessage)('field_value')(value));
        },
        onChange: onChange },
      values.map(function (d) {
        return _react2.default.createElement(_MenuItem2.default, {
          key: d,
          insetChildren: true,
          checked: value && value.includes(d),
          value: d,
          style: { fontSize: 13 },
          primaryText: _react2.default.createElement(_reactIntl.FormattedMessage, (0, _intl_helpers.createMessage)('field_value')(d))
        });
      })
    );
  }
  return _react2.default.createElement(ValueCell, { value: value, type: type, coordFormat: coordFormat });
});

var Row = function (_React$PureComponent) {
  (0, _inherits3.default)(Row, _React$PureComponent);

  function Row(props) {
    (0, _classCallCheck3.default)(this, Row);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Row.__proto__ || (0, _getPrototypeOf2.default)(Row)).call(this, props));

    _this.handleChange = _this.handleChange.bind(_this);
    _this.handleVisibilityChange = _this.handleVisibilityChange.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(Row, [{
    key: 'handleChange',
    value: function handleChange() {
      var value = void 0;
      if (arguments.length === 3) value = arguments[2];else value = arguments[1];
      this.props.onValueChange(this.props._key, value === 'undefined' ? undefined : value);
    }
  }, {
    key: 'handleVisibilityChange',
    value: function handleVisibilityChange() {
      this.props.onVisibilityChange(this.props._key, !this.props.visible);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          _key = _props._key,
          value = _props.value,
          type = _props.type,
          visible = _props.visible,
          editMode = _props.editMode,
          coordFormat = _props.coordFormat,
          fieldMetadata = _props.fieldMetadata,
          firstColWidth = _props.firstColWidth;

      var rowStyle = (0, _objectAssign2.default)({}, styles.row, { opacity: visible ? 1 : 0.6, borderBottomColor: editMode ? '#f0f0f0' : '#e0e0e0' });
      return _react2.default.createElement(
        'div',
        { key: _key, style: rowStyle },
        _react2.default.createElement(
          'div',
          { style: (0, _objectAssign2.default)({}, styles.column, styles.firstColumn, { width: firstColWidth }) },
          _react2.default.createElement(
            'span',
            { ref: 'firstColumn' },
            _react2.default.createElement(_formatted_fieldname2.default, { fieldname: _key })
          )
        ),
        _react2.default.createElement(
          'div',
          { style: (0, _objectAssign2.default)({}, styles.column, editMode && { minHeight: 30 }) },
          editMode ? _react2.default.createElement(ValueCellEdit, {
            key: _key,
            value: value,
            type: type,
            coordFormat: coordFormat,
            onChange: this.handleChange,
            fieldMetadata: fieldMetadata }) : _react2.default.createElement(ValueCell, { key: _key, value: value, type: type, coordFormat: coordFormat })
        ),
        editMode && _react2.default.createElement(
          'div',
          { style: (0, _objectAssign2.default)({}, styles.column, { padding: 0, flex: 'initial' }) },
          _react2.default.createElement(
            _IconButton2.default,
            {
              style: { width: 39, height: 39, padding: 5 },
              disableTouchRipple: true,
              onTouchTap: this.handleVisibilityChange },
            visible ? _react2.default.createElement(_visibility2.default, null) : _react2.default.createElement(_visibilityOff2.default, null)
          )
        )
      );
    }
  }]);
  return Row;
}(_react2.default.PureComponent);

var FeatureTable = function (_React$PureComponent2) {
  (0, _inherits3.default)(FeatureTable, _React$PureComponent2);

  function FeatureTable() {
    var _ref3;

    var _temp, _this2, _ret;

    (0, _classCallCheck3.default)(this, FeatureTable);

    for (var _len = arguments.length, args = Array(_len), _key2 = 0; _key2 < _len; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return _ret = (_temp = (_this2 = (0, _possibleConstructorReturn3.default)(this, (_ref3 = FeatureTable.__proto__ || (0, _getPrototypeOf2.default)(FeatureTable)).call.apply(_ref3, [this].concat(args))), _this2), _this2.state = {
      width: '50%',
      rows: []
    }, _temp), (0, _possibleConstructorReturn3.default)(_this2, _ret);
  }

  (0, _createClass3.default)(FeatureTable, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.setState({ rows: getRows(this.props) });
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.autoFitColumn();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.feature === this.props.feature && nextProps.editMode === this.props.editMode && nextProps.visibleFields === this.props.visibleFields) return;
      this.setState({ rows: getRows(nextProps) });
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var rows = this.state.rows;
      var didFeaturePropKeysChange = rows.length !== prevState.rows.length || rows.reduce(function (acc, row, i) {
        return acc || row.key !== prevState.rows[i].key;
      }, false);
      if (didFeaturePropKeysChange) {
        this.autoFitColumn();
      }
    }
  }, {
    key: 'autoFitColumn',
    value: function autoFitColumn() {
      var _this3 = this;

      var width = 0;
      this.state.rows.forEach(function (row) {
        var rowEl = _this3.refs[row.key].refs.firstColumn;
        width = Math.max(width, rowEl.offsetWidth);
      });
      this.setState({
        width: width + 1
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props2 = this.props,
          print = _props2.print,
          editMode = _props2.editMode,
          fieldAnalysis = _props2.fieldAnalysis;
      var rows = this.state.rows;
      // const firstColStyle = assign({}, styles.firstColumn, {width: this.state.width})
      // let secondColStyle = styles.secondColumn
      // if (print) {
      //   assign(firstColStyle, styles.smallRow)
      //   secondColStyle = assign({}, secondColStyle, styles.smallRow)
      // }
      // if (editMode) {
      //   secondColStyle = assign({}, secondColStyle, styles.editRow, styles.secondColumnEdit)
      // }

      return _react2.default.createElement(
        'div',
        null,
        rows.map(function (row, index) {
          return _react2.default.createElement(Row, (0, _extends3.default)({
            ref: row.key
          }, row, {
            _key: row.key
          }, _this4.props, {
            fieldMetadata: fieldAnalysis.properties[row.key],
            firstColWidth: _this4.state.width,
            index: index
          }));
        })
      );
    }
  }]);
  return FeatureTable;
}(_react2.default.PureComponent);

FeatureTable.defaultProps = {
  feature: {
    properties: {}
  }
};


var isNonEditableFieldType = (_isNonEditableFieldTy = {}, (0, _defineProperty3.default)(_isNonEditableFieldTy, _constants.FIELD_TYPE_UUID, true), (0, _defineProperty3.default)(_isNonEditableFieldTy, _constants.FIELD_TYPE_IMAGE, true), (0, _defineProperty3.default)(_isNonEditableFieldTy, _constants.FIELD_TYPE_VIDEO, true), (0, _defineProperty3.default)(_isNonEditableFieldTy, _constants.FIELD_TYPE_MEDIA, true), (0, _defineProperty3.default)(_isNonEditableFieldTy, _constants.FIELD_TYPE_AUDIO, true), _isNonEditableFieldTy);

function getRows(props) {
  var feature = props.feature,
      editMode = props.editMode,
      fieldAnalysis = props.fieldAnalysis,
      visibleFields = props.visibleFields,
      fieldOrder = props.fieldOrder;

  var rows = (0, _keys2.default)(fieldAnalysis.properties).map(function (key) {
    return {
      key: key,
      value: feature.properties[key],
      type: fieldAnalysis.properties[key].type,
      visible: visibleFields.indexOf(key) > -1
    };
  }).filter(function (row) {
    return !isNonEditableFieldType[row.type];
  });
  if (!editMode) {
    rows = rows.filter(function (row) {
      return visibleFields.indexOf(row.key) > -1 && (typeof row.value !== 'string' || row.value.length) && typeof row.value !== 'undefined';
    });
  }
  if (feature.geometry || editMode) {
    rows.unshift({
      key: 'location',
      value: feature.geometry && feature.geometry.coordinates,
      type: _constants.FIELD_TYPE_LOCATION,
      visible: visibleFields.indexOf('location') > -1
    });
  }
  return rows.sort(function (a, b) {
    var orderA = fieldOrder.hasOwnProperty(a.key) ? fieldOrder[a.key] : Infinity;
    var orderB = fieldOrder.hasOwnProperty(b.key) ? fieldOrder[b.key] : Infinity;
    return orderA - orderB;
  });
}

exports.default = FeatureTable;
//# sourceMappingURL=feature_table.js.map