'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _Card = require('material-ui/Card');

var _RaisedButton = require('material-ui/RaisedButton');

var _RaisedButton2 = _interopRequireDefault(_RaisedButton);

var _modeEdit = require('material-ui/svg-icons/editor/mode-edit');

var _modeEdit2 = _interopRequireDefault(_modeEdit);

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _close = require('material-ui/svg-icons/navigation/close');

var _close2 = _interopRequireDefault(_close);

var _reactIntl = require('react-intl');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _flat = require('flat');

var _formatted_value = require('../shared/formatted_value');

var _formatted_value2 = _interopRequireDefault(_formatted_value);

var _features_by_id = require('../../selectors/features_by_id');

var _features_by_id2 = _interopRequireDefault(_features_by_id);

var _field_mapping = require('../../selectors/field_mapping');

var _field_mapping2 = _interopRequireDefault(_field_mapping);

var _color_index = require('../../selectors/color_index');

var _color_index2 = _interopRequireDefault(_color_index);

var _visible_fields = require('../../selectors/visible_fields');

var _visible_fields2 = _interopRequireDefault(_visible_fields);

var _field_analysis = require('../../selectors/field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

var _image = require('../image');

var _image2 = _interopRequireDefault(_image);

var _marker_icon = require('./marker_icon');

var _marker_icon2 = _interopRequireDefault(_marker_icon);

var _feature_table = require('./feature_table');

var _feature_table2 = _interopRequireDefault(_feature_table);

var _action_creators = require('../../action_creators');

var _constants = require('../../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  card: {
    overflow: 'auto',
    width: '100%'
  },
  cardUnrestricted: {
    width: '100%'
  },
  header: {
    lineHeight: '22px',
    boxSizing: 'content-box',
    borderBottom: '1px solid #cccccc'
  },
  markerIcon: {
    width: 40,
    height: 40,
    margin: 0,
    marginRight: 16
  },
  media: {
    position: 'relative',
    height: '100%',
    padding: '67% 0 0 0'
  },
  img: {
    width: '100%',
    height: '100%',
    top: 0,
    left: 0,
    position: 'absolute',
    objectFit: 'cover'
  },
  button: {
    margin: '8px 16px 8px 8px'
  }
};

var messages = (0, _reactIntl.defineMessages)({
  editButton: {
    'id': 'feature.editButton',
    'defaultMessage': 'Edit'
  },
  closeButton: {
    'id': 'feature.closeButton',
    'defaultMessage': 'Close'
  },
  cancelButton: {
    'id': 'feature.cancelButton',
    'defaultMessage': 'Cancel'
  },
  saveButton: {
    'id': 'feature.saveButton',
    'defaultMessage': 'Save'
  }
});

var Actions = function Actions(_ref) {
  var style = _ref.style,
      editMode = _ref.editMode,
      onCloseClick = _ref.onCloseClick,
      onEditClick = _ref.onEditClick,
      onCancelClick = _ref.onCancelClick,
      onSaveClick = _ref.onSaveClick;
  return editMode ? _react2.default.createElement(
    _Card.CardActions,
    { style: style, className: 'no_print' },
    _react2.default.createElement(_RaisedButton2.default, {
      label: _react2.default.createElement(_reactIntl.FormattedMessage, messages.cancelButton),
      onTouchTap: onCancelClick,
      style: styles.button
    }),
    _react2.default.createElement(_RaisedButton2.default, {
      label: _react2.default.createElement(_reactIntl.FormattedMessage, messages.saveButton),
      primary: true,
      onTouchTap: onSaveClick,
      style: styles.button
    })
  ) : _react2.default.createElement(
    _Card.CardActions,
    { style: style, className: 'no_print' },
    _react2.default.createElement(_RaisedButton2.default, {
      label: _react2.default.createElement(_reactIntl.FormattedMessage, messages.editButton),
      icon: _react2.default.createElement(_modeEdit2.default, null),
      onTouchTap: onEditClick,
      style: styles.button
    }),
    _react2.default.createElement(_RaisedButton2.default, {
      label: _react2.default.createElement(_reactIntl.FormattedMessage, messages.closeButton),
      primary: true,
      onTouchTap: onCloseClick,
      style: styles.button
    })
  );
};

var FeatureDetail = function (_React$Component) {
  (0, _inherits3.default)(FeatureDetail, _React$Component);

  function FeatureDetail(props) {
    (0, _classCallCheck3.default)(this, FeatureDetail);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FeatureDetail.__proto__ || (0, _getPrototypeOf2.default)(FeatureDetail)).call(this, props));

    _this.state = {
      editMode: false
    };
    _this.handleEditClick = _this.handleEditClick.bind(_this);
    _this.handleCancelClick = _this.handleCancelClick.bind(_this);
    _this.handleSaveClick = _this.handleSaveClick.bind(_this);
    _this.handleValueChange = _this.handleValueChange.bind(_this);
    _this.handleVisibilityChange = _this.handleVisibilityChange.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(FeatureDetail, [{
    key: 'handleEditClick',
    value: function handleEditClick() {
      this.setState({
        editMode: true,
        feature: this.props.feature,
        visibleFields: this.props.visibleFields
      });
    }
  }, {
    key: 'handleCancelClick',
    value: function handleCancelClick() {
      this.setState({ editMode: false });
    }
  }, {
    key: 'handleSaveClick',
    value: function handleSaveClick() {
      if (this.state.feature !== this.props.feature) {
        var newFeature = untransformFeature(this.state.feature, this.props.fieldAnalysis);
        this.props.onEditFeature(newFeature);
      }
      if (this.state.visibleFields !== this.props.visibleFields) {
        this.props.onEditHiddenFields(this.state.visibleFields);
      }
      this.setState({ editMode: false });
    }
  }, {
    key: 'handleVisibilityChange',
    value: function handleVisibilityChange(key, visible) {
      var visibleFields = visible ? this.state.visibleFields.concat([key]) : this.state.visibleFields.filter(function (fieldname) {
        return fieldname !== key;
      });
      this.setState({ visibleFields: visibleFields });
    }
  }, {
    key: 'handleValueChange',
    value: function handleValueChange(key, value) {
      var feature = this.state.feature;
      var newFeature = (0, _objectAssign2.default)({}, feature, {
        properties: (0, _objectAssign2.default)({}, feature.properties, (0, _defineProperty3.default)({}, key, value))
      });
      this.setState({ feature: newFeature });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          color = _props.color,
          label = _props.label,
          media = _props.media,
          feature = _props.feature,
          title = _props.title,
          subtitle = _props.subtitle,
          onCloseClick = _props.onCloseClick,
          fieldOrder = _props.fieldOrder,
          print = _props.print,
          coordFormat = _props.coordFormat,
          fieldAnalysis = _props.fieldAnalysis,
          visibleFields = _props.visibleFields,
          titleType = _props.titleType,
          subtitleType = _props.subtitleType;
      var _state = this.state,
          editMode = _state.editMode,
          editedFeature = _state.feature,
          editedVisibleFields = _state.visibleFields;

      return _react2.default.createElement(
        _Card.Card,
        {
          className: 'card',
          style: styles.card,
          zDepth: 0 },
        _react2.default.createElement(
          _Card.CardHeader,
          {
            style: styles.header,
            avatar: _react2.default.createElement(_marker_icon2.default, { color: color, style: styles.markerIcon, label: label }),
            title: _react2.default.createElement(_formatted_value2.default, { value: title, type: titleType }),
            subtitle: _react2.default.createElement(_formatted_value2.default, { value: subtitle, type: subtitleType }) },
          onCloseClick && _react2.default.createElement(
            _IconButton2.default,
            { style: { float: 'right' }, onTouchTap: onCloseClick },
            _react2.default.createElement(_close2.default, null)
          )
        ),
        _react2.default.createElement(
          'div',
          null,
          media && _react2.default.createElement(
            _Card.CardMedia,
            { style: styles.media },
            _react2.default.createElement(_image2.default, { style: styles.img, src: media })
          ),
          _react2.default.createElement(
            _Card.CardText,
            null,
            _react2.default.createElement(_feature_table2.default, {
              editMode: editMode,
              feature: editMode ? editedFeature : feature,
              fieldAnalysis: fieldAnalysis,
              fieldOrder: fieldOrder,
              visibleFields: editMode ? editedVisibleFields : visibleFields,
              print: print,
              coordFormat: coordFormat,
              onVisibilityChange: this.handleVisibilityChange,
              onValueChange: this.handleValueChange
            })
          ),
          _react2.default.createElement(Actions, {
            style: { textAlign: 'right' },
            editMode: editMode,
            onChangeProp: this.handlePropEdit,
            onEditClick: this.handleEditClick,
            onCloseClick: onCloseClick,
            onCancelClick: this.handleCancelClick,
            onSaveClick: this.handleSaveClick
          })
        )
      );
    }
  }]);
  return FeatureDetail;
}(_react2.default.Component);

// The selectors transform input features, we want to undo this before we save


function untransformFeature(feature, fieldAnalysis) {
  var newProps = {};
  var prevProps = feature.properties;
  (0, _keys2.default)(prevProps).forEach(function (key) {
    if (typeof prevProps[key] === 'string') {
      newProps[key] = prevProps[key].trim();
    }
    switch (fieldAnalysis.properties[key].type) {
      case _constants.FIELD_TYPE_SPACE_DELIMITED:
        newProps[key] = Array.isArray(prevProps[key]) ? prevProps[key].join(' ') : prevProps[key];
        break;
      default:
        newProps[key] = prevProps[key];
    }
  });
  return (0, _flat.unflatten)((0, _objectAssign2.default)({}, feature, {
    properties: newProps
  }));
}

exports.default = (0, _reactRedux.connect)(function (state, ownProps) {
  var featuresById = (0, _features_by_id2.default)(state);
  var colorIndex = (0, _color_index2.default)(state);
  var fieldMapping = (0, _field_mapping2.default)(state);
  var visibleFields = (0, _visible_fields2.default)(state);
  var fieldAnalysis = (0, _field_analysis2.default)(state);
  var id = ownProps.id || state.ui.featureId;
  var feature = featuresById[id];
  if (!feature) return {};
  var geojsonProps = feature.properties;
  var fieldAnalysisProps = fieldAnalysis.properties;
  return {
    coordFormat: state.settings.coordFormat,
    feature: feature,
    fieldAnalysis: fieldAnalysis,
    fieldOrder: state.fieldOrder,
    visibleFields: visibleFields,
    media: geojsonProps[fieldMapping.media],
    title: geojsonProps[fieldMapping.title],
    subtitle: geojsonProps[fieldMapping.subtitle],
    color: colorIndex[geojsonProps[fieldMapping.color]] || geojsonProps[fieldMapping.color] && colorIndex[geojsonProps[fieldMapping.color][0]],
    titleType: fieldAnalysisProps[fieldMapping.title] && fieldAnalysisProps[fieldMapping.title].type,
    subtitleType: fieldAnalysisProps[fieldMapping.subtitle] && fieldAnalysisProps[fieldMapping.subtitle].type
  };
}, function (dispatch) {
  return {
    onEditFeature: function onEditFeature(feature) {
      return dispatch((0, _action_creators.editFeature)(feature));
    },
    onEditHiddenFields: function onEditHiddenFields(visibleFields) {
      return dispatch((0, _action_creators.updateVisibleFields)(visibleFields));
    }
  };
})(FeatureDetail);
//# sourceMappingURL=index.js.map