'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _pure = require('recompose/pure');

var _pure2 = _interopRequireDefault(_pure);

var _Checkbox = require('material-ui/Checkbox');

var _Checkbox2 = _interopRequireDefault(_Checkbox);

var _list = require('material-ui/svg-icons/action/list');

var _list2 = _interopRequireDefault(_list);

var _List = require('material-ui/List');

var _reactIntl = require('react-intl');

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _show_all_button = require('./show_all_button');

var _show_all_button2 = _interopRequireDefault(_show_all_button);

var _only_button = require('./only_button');

var _only_button2 = _interopRequireDefault(_only_button);

var _intl_helpers = require('../../util/intl_helpers');

var _styles = require('../../styles');

var _constants = require('../../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PureCheckbox = (0, _pure2.default)(_Checkbox2.default);

var styles = {
  checkbox: {
    marginBottom: 8,
    fontSize: 14
  },
  checkboxLabel: {
    lineHeight: '22px',
    whiteSpace: 'nowrap',
    overflow: 'hidden',
    textOverflow: 'ellipsis'
  },
  coloredSpan: {
    backgroundColor: 'rgb(0, 188, 212)',
    borderRadius: 2,
    padding: '2px 5px',
    color: 'white',
    letterSpacing: '0.02em'
  },
  checkboxIcon: {
    width: 20,
    height: 20,
    marginRight: 14
  }
};

// Material-ui passes a `nestedLevel` prop to nested items.
// We're not using a `div` instead of the material-ui component for
// nested items, so we need to remove the `nestedLevel` prop.
var NestedItem = function NestedItem(props) {
  var divProps = (0, _omit2.default)(props, ['nestedLevel', 'children']);
  return _react2.default.createElement(
    'div',
    divProps,
    props.children
  );
};

var DiscreteFilter = function (_React$PureComponent) {
  (0, _inherits3.default)(DiscreteFilter, _React$PureComponent);

  function DiscreteFilter() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, DiscreteFilter);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = DiscreteFilter.__proto__ || (0, _getPrototypeOf2.default)(DiscreteFilter)).call.apply(_ref, [this].concat(args))), _this), _this.state = {}, _this.showAll = function (e) {
      e.preventDefault();
      _this.props.onUpdate({
        exp: 'in',
        key: _this.props.fieldName,
        val: null
      });
    }, _this.handleCheck = function (value, e) {
      var checked = _this.props.checked.slice(0);
      if (e.target.checked && checked.indexOf(value) === -1) {
        checked.push(value);
      } else if (!e.target.checked && checked.indexOf(value) > -1) {
        checked.splice(checked.indexOf(value), 1);
      }
      _this.props.onUpdate({
        exp: 'in',
        key: _this.props.fieldName,
        val: checked
      });
    }, _this.handleMouseLeave = function () {
      _this.setState({ hovered: false });
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(DiscreteFilter, [{
    key: 'handleOnlyClick',
    value: function handleOnlyClick(key, e) {
      e.preventDefault();
      this.props.onUpdate({
        exp: 'in',
        key: this.props.fieldName,
        val: [key]
      });
    }
  }, {
    key: 'handleMouseEnter',
    value: function handleMouseEnter(key) {
      this.setState({ hovered: key });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          fieldName = _props.fieldName,
          checked = _props.checked,
          values = _props.values,
          colored = _props.colored,
          colorIndex = _props.colorIndex,
          formatMessage = _props.intl.formatMessage;

      var isFiltered = checked.length < values.length;
      var title = fieldName.split('.').slice(-1)[0];
      var subTitle = fieldName.indexOf('.') > 1 ? fieldName.split('.').slice(0, -1).join(' / ') : null;

      return _react2.default.createElement(_List.ListItem, {
        innerDivStyle: _styles.listStyles.listItemInner,
        primaryText: formatMessage((0, _intl_helpers.createMessage)('field_key')(title)),
        secondaryText: subTitle && formatMessage((0, _intl_helpers.createMessage)('field_key')(subTitle)),
        leftIcon: _react2.default.createElement(_list2.default, { style: _styles.listStyles.listIcon }),
        initiallyOpen: true,
        disabled: true,
        rightIconButton: isFiltered ? _react2.default.createElement(_show_all_button2.default, { onTouchTap: this.showAll }) : null,
        nestedListStyle: _styles.listStyles.nestedList,
        nestedItems: values.map(function (v) {
          return _react2.default.createElement(
            NestedItem,
            {
              key: v.value,
              style: { position: 'relative' },
              onMouseEnter: _this2.handleMouseEnter.bind(_this2, v.value),
              onMouseLeave: _this2.handleMouseLeave },
            _react2.default.createElement(PureCheckbox, {
              label: _react2.default.createElement(
                'span',
                { style: colored ? (0, _objectAssign2.default)({}, styles.coloredSpan, { backgroundColor: colorIndex[v.value] }) : null },
                formatMessage((0, _intl_helpers.createMessage)('field_value')(v.value + ''))
              ),
              title: formatMessage((0, _intl_helpers.createMessage)('field_value')(v.value + '')),
              value: v.value,
              style: styles.checkbox,
              iconStyle: styles.checkboxIcon,
              labelStyle: styles.checkboxLabel,
              checked: checked.indexOf(v.value) > -1,
              onCheck: _this2.handleCheck.bind(_this2, v.value),
              disableFocusRipple: true,
              disableTouchRipple: true }),
            _this2.state.hovered === v.value && _react2.default.createElement(_only_button2.default, {
              onTouchTap: _this2.handleOnlyClick.bind(_this2, v.value) })
          );
        })
      });
    }
  }]);
  return DiscreteFilter;
}(_react2.default.PureComponent);

DiscreteFilter.propTypes = {
  fieldName: _propTypes2.default.string.isRequired,
  checked: _propTypes2.default.array,
  values: _propTypes2.default.arrayOf(_propTypes2.default.object),
  onUpdate: _propTypes2.default.func
};
DiscreteFilter.defaultProps = {
  checked: [],
  onUpdate: function onUpdate(x) {
    return x;
  }
};
exports.default = (0, _reactIntl.injectIntl)(DiscreteFilter);
//# sourceMappingURL=discrete_filter.js.map