'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

var _reactRedux = require('react-redux');

var _colorManipulator = require('material-ui/utils/colorManipulator');

var _image = require('..//image');

var _image2 = _interopRequireDefault(_image);

var _formatted_value = require('../shared/formatted_value');

var _formatted_value2 = _interopRequireDefault(_formatted_value);

var _features_by_id = require('../../selectors/features_by_id');

var _features_by_id2 = _interopRequireDefault(_features_by_id);

var _field_mapping = require('../../selectors/field_mapping');

var _field_mapping2 = _interopRequireDefault(_field_mapping);

var _color_index = require('../../selectors/color_index');

var _color_index2 = _interopRequireDefault(_color_index);

var _field_analysis = require('../../selectors/field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  wrapper: {
    width: 200,
    padding: 0,
    backgroundColor: 'black',
    cursor: 'pointer',
    position: 'absolute',
    willChange: 'transform',
    top: 0,
    left: 0,
    pointerEvents: 'none'
  },
  image: {
    width: 200,
    height: 200,
    objectFit: 'cover',
    display: 'block',
    background: '#000000'
  },
  title: {
    position: 'absolute',
    bottom: 0,
    width: '100%',
    backgroundColor: 'rgba(0,0,0,0.5)',
    color: 'white'
  },
  h1: {
    margin: '6px 8px 0',
    fontSize: '1.4em'
  },
  h2: {
    margin: '0 8px 5px',
    fontStyle: 'normal',
    fontSize: '1em'
  }
};

var Popup = function (_React$Component) {
  (0, _inherits3.default)(Popup, _React$Component);

  function Popup(props) {
    (0, _classCallCheck3.default)(this, Popup);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Popup.__proto__ || (0, _getPrototypeOf2.default)(Popup)).call(this, props));

    _this.state = {};

    _this.update = function (lngLat) {
      if (!Array.isArray(lngLat) || lngLat.length !== 2) lngLat = _this.props.lngLat;
      var w = _this._el.offsetWidth;
      var h = _this._el.offsetHeight;
      _this.setState({
        transform: getPopupTransform(_this.map, lngLat, w, h, _this.props.offset)
      });
    };

    _this.map = props.map;
    return _this;
  }

  (0, _createClass3.default)(Popup, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var lngLat = this.props.lngLat;

      this.map.on('move', this.update);
      this.update(lngLat);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(_ref) {
      var lngLat = _ref.lngLat;

      this.update(lngLat);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.map.off('move', this.update);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          media = _props.media,
          title = _props.title,
          subtitle = _props.subtitle,
          color = _props.color,
          titleType = _props.titleType,
          subtitleType = _props.subtitleType;
      var transform = this.state.transform;


      return _react2.default.createElement(
        'div',
        { style: (0, _objectAssign2.default)({}, styles.wrapper, { transform: transform }), ref: function ref(el) {
            return _this2._el = el;
          } },
        media && _react2.default.createElement(_image2.default, { src: media, style: styles.image }),
        _react2.default.createElement(
          'div',
          { style: (0, _objectAssign2.default)({}, styles.title, {
              backgroundColor: (0, _colorManipulator.fade)((0, _colorManipulator.darken)(color || '#000', 0.5), 0.5)
            }) },
          title && _react2.default.createElement(
            'h1',
            { style: styles.h1 },
            _react2.default.createElement(_formatted_value2.default, { value: title, type: titleType })
          ),
          subtitle && _react2.default.createElement(
            'h2',
            { style: (0, _objectAssign2.default)({}, styles.h1, styles.h2) },
            _react2.default.createElement(_formatted_value2.default, { value: subtitle, type: subtitleType })
          )
        )
      );
    }
  }]);
  return Popup;
}(_react2.default.Component);

Popup.defaultProps = {
  offset: {
    x: 0,
    y: 0
  }
};


function getPopupTransform(map, lngLat, width, height) {
  var offset = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : { x: 0, y: 0 };

  var pos = map.project(lngLat).round();
  var anchor = void 0;

  if (pos.y < height) {
    anchor = 'top';
  } else {
    anchor = 'bottom';
  }

  if (pos.x > map.transform.width - width) {
    anchor += '-right';
  } else {
    anchor += '-left';
  }

  var anchorTranslate = {
    'top-left': 'translate(0,0)',
    'top-right': 'translate(-100%,0)',
    'bottom-left': 'translate(0,-100%)',
    'bottom-right': 'translate(-100%,-100%)'
  };

  return anchorTranslate[anchor] + ' translate(' + (pos.x + offset.x) + 'px,' + (pos.y + offset.y) + 'px)';
}

exports.default = (0, _reactRedux.connect)(function (state, ownProps) {
  var featuresById = (0, _features_by_id2.default)(state);
  var colorIndex = (0, _color_index2.default)(state);
  var fieldMapping = (0, _field_mapping2.default)(state);
  var feature = featuresById[ownProps.id];
  if (!feature) return {};
  var geojsonProps = feature.properties;
  var fieldAnalysisProps = (0, _field_analysis2.default)(state).properties;
  return {
    media: geojsonProps[fieldMapping.media],
    title: geojsonProps[fieldMapping.title],
    subtitle: geojsonProps[fieldMapping.subtitle],
    color: colorIndex[geojsonProps[fieldMapping.color]],
    titleType: fieldAnalysisProps[fieldMapping.title] && fieldAnalysisProps[fieldMapping.title].type,
    subtitleType: fieldAnalysisProps[fieldMapping.subtitle] && fieldAnalysisProps[fieldMapping.subtitle].type
  };
})(Popup);
//# sourceMappingURL=popup.js.map