'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Paper = require('material-ui/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _insertCss = require('insert-css');

var _insertCss2 = _interopRequireDefault(_insertCss);

var _feature_detail = require('../feature_detail');

var _feature_detail2 = _interopRequireDefault(_feature_detail);

var _prop_types = require('../../util/prop_types');

var MFPropTypes = _interopRequireWildcard(_prop_types);

var _map = require('../map');

var _map2 = _interopRequireDefault(_map);

var _alert = require('./alert');

var _alert2 = _interopRequireDefault(_alert);

var _config = require('../../../config.json');

var _config2 = _interopRequireDefault(_config);

var _constants = require('../../constants');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _insertCss2.default)('\n.report_wrapper {\n  overflow: scroll;\n  position: absolute;\n  width: 100%;\n  height: 100%;\n}\n.report_container {\n  display: flex;\n  flex-grow: 1;\n  flex-wrap: wrap;\n  background-color: rgba(236, 236, 236, 1);\n  padding: 0 20px\n}\n.report_paper {\n  margin: 20px auto;\n  width: 8.5in;\n  min-height: 10.5in;\n  overflow: hidden;\n  page-break-after: always;\n  background-color: initial;\n  position: relative;\n}\n.report_paper:last-child {\n  page-break-after: avoid !important;\n}\n.map_container {\n  flex: 1;\n  position: relative;\n}\n.page_break {\n  position: absolute;\n  left: 0;\n  top: 10.5in;\n  width: 100%;\n  border: none;\n  margin: 0;\n  border-bottom: 3px dashed rgba(200,200,200, 0.75);\n}\n\n.report_page {\n  margin: 0.5in;\n}\n@page {\n  margin: 0.5in;\n}\n.report_paper:first-child {\n  display: flex;\n  height: 9.8in;\n}\n.report_paper:first-child .report_page {\n  flex: 1;\n  display: flex;\n  flex-direction: column;\n}\n@media only print {\n  body, html {\n    overflow: visible;\n  }\n  /* Override display: flex which breaks page-break-after */\n  .outer.container, .inner.container {\n    display: block !important;\n  }\n  /* Fix for page-break-after not working in Chrome see http://stackoverflow.com/questions/4884380/css-page-break-not-working-in-all-browsers/5314590 */\n  div {\n    float: none !important;\n  }\n  tr {\n    page-break-inside: avoid;\n  }\n  /* Override fixed positioning of top level div */\n  #root .outer.container {\n    position: relative !important;\n  }\n  .report_wrapper {\n    position: relative;\n    width: auto;\n    height: auto;\n  }\n  .report_container {\n    display: block;\n    padding: 0;\n    overflow: visible;\n    background-color: initial;\n  }\n  .report_paper {\n    min-height: auto;\n    box-shadow: none !important;\n    border-radius: 0 !important;\n    margin: 0;\n    width: 7.5in;\n  }\n  .no_print {\n    display: none;\n  }\n  .report_page {\n    margin: 0\n  }\n  /* TODO include some form of MapFilter header */\n  /* TODO rotate the filter display and show state vs. allow interaction */\n  .mapboxgl-control-container,\n  .nav.container,\n  .page_break,\n  .report_header,\n  .filter {\n    display: none !important;\n  }\n}\n');

var ReportView = function (_React$Component) {
  (0, _inherits3.default)(ReportView, _React$Component);

  function ReportView() {
    (0, _classCallCheck3.default)(this, ReportView);
    return (0, _possibleConstructorReturn3.default)(this, (ReportView.__proto__ || (0, _getPrototypeOf2.default)(ReportView)).apply(this, arguments));
  }

  (0, _createClass3.default)(ReportView, [{
    key: 'render',
    value: function render() {
      var filteredFeatures = this.props.filteredFeatures;

      var featuresSlice = filteredFeatures.length > 26 ? filteredFeatures.slice(0, 26) : filteredFeatures;
      return _react2.default.createElement(
        'div',
        { className: 'report_wrapper' },
        _react2.default.createElement(
          'div',
          { className: 'report_header' },
          filteredFeatures.length > 26 && _react2.default.createElement(_alert2.default, { label: 'Current filters show ' + filteredFeatures.length + ' records, a report will only show the first 26 records' })
        ),
        _react2.default.createElement(
          'div',
          { className: 'report_container' },
          _react2.default.createElement(
            _Paper2.default,
            { className: 'report_paper' },
            _react2.default.createElement(
              'div',
              { className: 'report_page' },
              _react2.default.createElement(
                'h2',
                null,
                'Monitoring Report'
              ),
              _react2.default.createElement(
                'p',
                { style: { marginTop: 0 } },
                featuresSlice.length,
                ' locations'
              ),
              _react2.default.createElement(
                'div',
                { className: 'map_container' },
                _react2.default.createElement(_map2.default, (0, _extends3.default)({}, this.props, {
                  features: featuresSlice,
                  interactive: false,
                  labelPoints: true
                }))
              )
            )
          ),
          featuresSlice.map(function (feature, i) {
            return _react2.default.createElement(
              _Paper2.default,
              { className: 'report_paper', key: i },
              _react2.default.createElement(
                'div',
                { className: 'report_page' },
                _react2.default.createElement(_feature_detail2.default, {
                  key: i,
                  id: feature.id,
                  label: _config2.default.labelChars.charAt(i),
                  print: true
                })
              ),
              _react2.default.createElement('hr', { className: 'page_break' })
            );
          }),
          featuresSlice.length > 20 && _react2.default.createElement(
            _Paper2.default,
            { className: 'report_paper' },
            _react2.default.createElement(
              'div',
              { className: 'report_page' },
              _react2.default.createElement(
                'h2',
                null,
                'Cannot print more than 26 observations in a single report'
              )
            )
          )
        )
      );
    }
  }]);
  return ReportView;
}(_react2.default.Component);

ReportView.propTypes = {
  filteredFeatures: _propTypes2.default.arrayOf(MFPropTypes.mapViewFeature).isRequired,
  fieldMapping: MFPropTypes.fieldMapping,
  filter: MFPropTypes.mapboxFilter
};
exports.default = ReportView;
//# sourceMappingURL=index.js.map