'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _titleFieldTypes; // import PropTypes from 'prop-types'


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _List = require('material-ui/List');

var _SelectField = require('material-ui/SelectField');

var _SelectField2 = _interopRequireDefault(_SelectField);

var _MenuItem = require('material-ui/MenuItem');

var _MenuItem2 = _interopRequireDefault(_MenuItem);

var _field_analysis = require('../../selectors/field_analysis');

var _field_analysis2 = _interopRequireDefault(_field_analysis);

var _field_mapping = require('../../selectors/field_mapping');

var _field_mapping2 = _interopRequireDefault(_field_mapping);

var _formatted_fieldname = require('../shared/formatted_fieldname');

var _formatted_fieldname2 = _interopRequireDefault(_formatted_fieldname);

var _action_creators = require('../../action_creators');

var _constants = require('../../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var titleFieldTypes = (_titleFieldTypes = {}, (0, _defineProperty3.default)(_titleFieldTypes, _constants.FIELD_TYPE_STRING, true), (0, _defineProperty3.default)(_titleFieldTypes, _constants.FIELD_TYPE_DATE, true), _titleFieldTypes);

var GeneralSettings = function (_React$Component) {
  (0, _inherits3.default)(GeneralSettings, _React$Component);

  function GeneralSettings() {
    (0, _classCallCheck3.default)(this, GeneralSettings);
    return (0, _possibleConstructorReturn3.default)(this, (GeneralSettings.__proto__ || (0, _getPrototypeOf2.default)(GeneralSettings)).apply(this, arguments));
  }

  (0, _createClass3.default)(GeneralSettings, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          onChangeCoordinates = _props.onChangeCoordinates,
          onChangeFieldMapping = _props.onChangeFieldMapping,
          coordFormat = _props.coordFormat,
          fields = _props.fields,
          fieldAnalysis = _props.fieldAnalysis,
          fieldMapping = _props.fieldMapping;

      var potentialColoredFields = fields.filter(function (field) {
        return fieldAnalysis.properties[field].filterType === _constants.FILTER_TYPE_DISCRETE;
      });
      var potentialTitleFields = fields.filter(function (field) {
        return titleFieldTypes[fieldAnalysis.properties[field].type];
      });
      return _react2.default.createElement(
        _List.List,
        null,
        _react2.default.createElement(_List.ListItem, {
          primaryText: 'Coordinate format',
          disabled: true,
          rightIconButton: _react2.default.createElement(
            _SelectField2.default,
            {
              value: coordFormat,
              onChange: onChangeCoordinates,
              autowidth: true
            },
            _react2.default.createElement(_MenuItem2.default, { value: _constants.FORMATS_DEC_DEG, primaryText: 'Decimal degrees' }),
            _react2.default.createElement(_MenuItem2.default, { value: _constants.FORMATS_DEG_MIN_SEC, primaryText: 'Degrees, minutes, seconds' }),
            _react2.default.createElement(_MenuItem2.default, { value: _constants.FORMATS_UTM, primaryText: 'UTM' })
          )
        }),
        _react2.default.createElement(_List.ListItem, {
          primaryText: 'Title field',
          disabled: true,
          rightIconButton: _react2.default.createElement(
            _SelectField2.default,
            {
              value: fieldMapping.title,
              onChange: onChangeFieldMapping.bind(null, 'title'),
              autowidth: true,
              maxHeight: 400
            },
            potentialTitleFields.map(function (field, i) {
              return _react2.default.createElement(_MenuItem2.default, { key: i, value: field, primaryText: _react2.default.createElement(_formatted_fieldname2.default, { fieldname: field }) });
            })
          )
        }),
        _react2.default.createElement(_List.ListItem, {
          key: 3,
          primaryText: 'Subtitle field',
          disabled: true,
          rightIconButton: _react2.default.createElement(
            _SelectField2.default,
            {
              value: fieldMapping.subtitle,
              onChange: onChangeFieldMapping.bind(null, 'subtitle'),
              autowidth: true,
              maxHeight: 400
            },
            potentialTitleFields.map(function (field, i) {
              return _react2.default.createElement(_MenuItem2.default, { key: i, value: field, primaryText: _react2.default.createElement(_formatted_fieldname2.default, { fieldname: field }) });
            })
          )
        }),
        _react2.default.createElement(_List.ListItem, {
          key: 4,
          primaryText: 'Colored field',
          disabled: true,
          rightIconButton: _react2.default.createElement(
            _SelectField2.default,
            {
              value: fieldMapping.color,
              onChange: onChangeFieldMapping.bind(null, 'color'),
              autowidth: true,
              maxHeight: 400
            },
            potentialColoredFields.map(function (field, i) {
              return _react2.default.createElement(_MenuItem2.default, { key: i, value: field, primaryText: _react2.default.createElement(_formatted_fieldname2.default, { fieldname: field }) });
            })
          )
        })
      );
    }
  }]);
  return GeneralSettings;
}(_react2.default.Component);

function mapStateToProps(state) {
  return {
    coordFormat: state.settings.coordFormat,
    fields: (0, _keys2.default)((0, _field_analysis2.default)(state).properties),
    fieldAnalysis: (0, _field_analysis2.default)(state),
    fieldMapping: (0, _field_mapping2.default)(state)
  };
}

function mapDispatchToProps(dispatch) {
  return {
    onChangeCoordinates: function onChangeCoordinates(e, i, coordFormat) {
      return dispatch((0, _action_creators.changeCoordinates)(coordFormat));
    },
    onChangeFieldMapping: function onChangeFieldMapping(type, e, i, field) {
      return dispatch((0, _action_creators.updateFieldMapping)({ type: type, field: field }));
    }
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(GeneralSettings);
//# sourceMappingURL=general.js.map