'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _Card = require('material-ui/Card');

var _IconButton = require('material-ui/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _FlatButton = require('material-ui/FlatButton');

var _FlatButton2 = _interopRequireDefault(_FlatButton);

var _close = require('material-ui/svg-icons/navigation/close');

var _close2 = _interopRequireDefault(_close);

var _reactIntl = require('react-intl');

var _action_creators = require('../../action_creators');

var _filter_configurator = require('./filter_configurator');

var _filter_configurator2 = _interopRequireDefault(_filter_configurator);

var _general = require('./general');

var _general2 = _interopRequireDefault(_general);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var styles = {
  card: {
    maxHeight: '100%',
    width: '100%',
    flex: 1,
    display: 'flex',
    flexDirection: 'column'
  },
  title: {
    borderBottom: '1px solid #e0e0e0',
    boxSizing: 'border-box',
    color: '#212121',
    margin: 0,
    fontWeight: 'normal',
    padding: '1em',
    position: 'relative'
  },
  tabList: {
    borderRight: '1px solid #e0e0e0',
    flex: 1
  },
  tabLabel: {
    textTransform: 'none',
    fontWeight: 'normal'
  },
  tabLabelActive: {
    textTransform: 'none',
    fontWeight: 'bold'
  },
  tab: {
    textAlign: 'left',
    height: 48,
    lineHeight: '48px'
  },
  tabActive: {
    textAlign: 'left',
    height: 48,
    lineHeight: '48px',
    backgroundColor: 'rgba(0,0,0,.05)'
  },
  body: {
    display: 'flex'
  },
  content: {
    flex: 3
  },
  cardContainerStyle: {
    flex: 1,
    flexDirection: 'column',
    display: 'flex'
  },
  header: {
    lineHeight: '22px',
    boxSizing: 'content-box',
    borderBottom: '1px solid #cccccc'
  },
  icon: {
    position: 'absolute',
    top: 7,
    right: 7
  },
  scrollable: {
    overflow: 'auto'
  }
};

var messages = (0, _reactIntl.defineMessages)({
  settingsTitle: {
    'id': 'settings.title',
    'defaultMessage': 'Settings'
  },
  filters: {
    'id': 'settings.filters',
    'defaultMessage': 'Change Filters'
  },
  fields: {
    'id': 'settings.fields',
    'defaultMessage': 'Visible Fields'
  },
  general: {
    'id': 'settings.general',
    'defaultMessage': 'General'
  }
});

var tabs = [{
  id: 'general',
  component: _general2.default
}, {
  id: 'filters',
  component: _filter_configurator2.default
}];

var Tab = function Tab(_ref) {
  var active = _ref.active,
      label = _ref.label,
      onClick = _ref.onClick;
  return _react2.default.createElement(_FlatButton2.default, {
    fullWidth: true,
    label: label,
    style: active ? styles.tabActive : styles.tab,
    labelStyle: active ? styles.tabLabelActive : styles.tabLabel,
    onTouchTap: onClick });
};

var Settings = function (_React$Component) {
  (0, _inherits3.default)(Settings, _React$Component);

  function Settings() {
    (0, _classCallCheck3.default)(this, Settings);
    return (0, _possibleConstructorReturn3.default)(this, (Settings.__proto__ || (0, _getPrototypeOf2.default)(Settings)).apply(this, arguments));
  }

  (0, _createClass3.default)(Settings, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          onCloseClick = _props.onCloseClick,
          activeTabId = _props.activeTabId,
          onChangeTab = _props.onChangeTab;

      var tabIndex = getTabIndex(activeTabId);
      var TabComponent = tabs[tabIndex].component;
      return _react2.default.createElement(
        _Card.Card,
        {
          style: styles.card,
          containerStyle: styles.cardContainerStyle,
          zDepth: 2 },
        _react2.default.createElement(
          'h3',
          { style: styles.title },
          _react2.default.createElement(_reactIntl.FormattedMessage, messages.settingsTitle),
          _react2.default.createElement(
            _IconButton2.default,
            { style: styles.icon, onTouchTap: onCloseClick },
            _react2.default.createElement(_close2.default, null)
          )
        ),
        _react2.default.createElement(
          'div',
          { style: styles.body },
          _react2.default.createElement(
            'div',
            { style: styles.tabList },
            tabs.map(function (tab, i) {
              return _react2.default.createElement(Tab, {
                key: i,
                label: _react2.default.createElement(_reactIntl.FormattedMessage, messages[tab.id]),
                active: i === tabIndex,
                onClick: onChangeTab.bind(null, tab.id) });
            })
          ),
          _react2.default.createElement(
            'div',
            { style: styles.content },
            _react2.default.createElement(TabComponent, null)
          )
        )
      );
    }
  }]);
  return Settings;
}(_react2.default.Component);

Settings.propTypes = {
  onCloseClick: _propTypes2.default.func.isRequired,
  onChangeTab: _propTypes2.default.func.isRequired,
  activeTabId: _propTypes2.default.string
};


function getTabIndex(tabId) {
  for (var i = 0; i < tabs.length; i++) {
    if (tabs[i].id === tabId) return i;
  }
  return 0;
}

function mapDispatchToProps(dispatch) {
  return {
    onChangeTab: function onChangeTab(settingsTab) {
      return dispatch((0, _action_creators.openSettings)(settingsTab));
    }
  };
}

exports.default = (0, _reactRedux.connect)(function (state) {
  return state;
}, mapDispatchToProps)(Settings);
//# sourceMappingURL=index.js.map